/**
* @file crc32.h
* @brief CRC32 header
* @author Kosenkov
* @date 31.01.2018
*/

#ifndef __CRC32_H__
#define __CRC32_H__

#include "types.h"

#define CRC32_INITIAL_CTX ((uint32_t)0)

/**
* CRC32 realization. The polynomial is
* X^32+X^26+X^23+X^22+X^16+X^12+X^11+X^10+X^8+X^7+X^5+X^4+X^2+X^1+X^0
* 
* @param ctx Context from previous step. Initial ctx is 0
* @param buf Data buffer
* @param sz Size of buffer
* @return crc32
* @author Kosenkov
* @date 18.05.2018
*/
uint32_t crc32(uint32_t ctx, const uint8_t* buf, Sz8 sz);

#endif
