/**
* @file rngTest.h
* @brief FIPS 140-2, section 4.9.1 test header
* @author Kosenkov
* @date 23.05.2018
*/

#ifndef __RNGTEST_H__
#define __RNGTEST_H__

#include "types.h"

#define STAT_CNT        ((uint32_t)2500)

/**
* Initialize read-write global variables inside the code, which work
* after scramber initialization
*
* @author Kosenkov
* @date 25.07.2018
*/
void rngTestInit(void);

/**
* The function randomTest performs testing step of FIPS 140-2, section 4.9.1 of 
* byte
* 
* @param byte Random byte that should be tested
* @author Kosenkov
* @date 05.06.2018
*/
void rngTestByte(uint8_t byte);

/**
* Check results of all tests
* 
* @retval CM0_OK if success
* @retval CM0_RNG_TEST_ERR otherwise
* @author Kosenkov
* @date 05.06.2018
*/
CM0_STATUS rngTestResult(void);

#endif
