/**
* @file gpio.h
* @brief GPIO unit header
* @author Kosenkov
* @date 29.03.2018
*/

#ifndef __GPIO_H__
#define __GPIO_H__

#include "types.h"

/**
* Gets pin mode
*
* @param pin Number
* @return Mode
* @author Kosenkov
* @date 18.05.2018
*/
uint8_t gpioGetPinMode(uint8_t pin);

/**
* Sets pin mode
*
* @param mode To set
* @param pin Number
* @author Kosenkov
* @date 18.05.2018
*/
void gpioSetPinMode(uint8_t mode, uint8_t pin);

/**
* Gets pin slew rate
*
* @param pin Number
* @return Slew rate
* @author Kosenkov
* @date 18.05.2018
*/
uint8_t gpioGetSlewRate(uint8_t pin);

/**
* Sets pin slew rate
*
* @param sr Slew rate to set
* @param pin Number
* @author Kosenkov
* @date 18.05.2018
*/
void gpioSetSlewRate(uint8_t sr, uint8_t pin);

/**
* Gets pin pull mode (pull up/pull down)
*
* @param pin Number
* @return Pull mode
* @author Kosenkov
* @date 18.05.2018
*/
uint8_t gpioGetPUPD(uint8_t pin);

/**
* Sets pin pull mode (pull up/pull down)
*
* @param pupd Mode to set
* @param pin Number
* @author Kosenkov
* @date 18.05.2018
*/
void gpioSetPUPD(uint8_t pupd, uint8_t pin);

#endif
