#include "cm0.h"
#include "uart.h"
#include "rng.h"
#include "gate.h"

#define CM0_CLOCK               ((uint32_t)8000000)
#define CM0_UART_BAUDRATE   ((uint32_t)9600)

int main (void)
{
	SYS->PEN = SYS_PEN_ALL;
	rngSetClock(CM0_CLOCK); //RNG->CLK_DIV = 7;
	rngSetMode(RNG_WORK_MODE_ALWAYS); //RNG->STAT_CTRL = RNG_WORK_MODE_ALWAYS | RNG_GEN_0 | RNG_EN_STATE;
	uartInit(CM0_CLOCK, CM0_UART_BAUDRATE);
	
	uartWrite("\r\n Hello from CRYPTO! \r\n", 24);
    uartWrite("\r\n Start working random number generator! \r\n", 44);
    uartWrite("\r\n Numbers are sent from uart and from gate REG_14! \r\n", 54);
    
	while (1) {
        for (int i=0; i < 2000000; i++); 
		uint32_t w;
		rngGetWord(&w);
		uartWrite((uint8_t*)&w, sizeof(uint32_t));
		gateSetReg(GATE0, GATE_REG_14, w);
	}
}
